library ieee;
use ieee.std_logic_1164.all;

entity ls373 is
	port(
		oe,le: in std_logic;
		d: in std_logic_vector(7 downto 0);
		q: out std_logic_vector(7 downto 0)
		);
end ls373;

architecture behave of ls373 is
	signal temp: std_logic_vector(7 downto 0);
begin
	process(oe,temp) 
	begin
		if(oe = '0') then
			q <= temp;
		else
			q <= "ZZZZZZZZ";
		end if;
	end process;
	process(le,d)
	begin
		if(le = '1') then
			temp <= d;
		end if;
	end process;
end behave;