library ieee;
use ieee.std_logic_1164.all;

entity mealy is
	port(
		clk,x: in std_logic;
		y: out std_logic;
		qout: out std_logic_vector(1 downto 0)
		);
end mealy;

architecture behave of mealy is
	type state is(s0,s1,s2,s3);
	signal cstate,nstate: state;
begin
	process(clk)
	begin
		if(clk'event and clk = '1') then
				cstate <= nstate;
			end if;
	end process;
	process(cstate,x)
	begin
		case cstate is
			when s0 => qout <= "00";
						if(x = '0') then
							nstate <= s0;
							y <= '0';
						else
							nstate <= s1;
							y <= '0';
						end if;
			when s1 => qout <= "01";
							if(x = '0') then
							nstate <= s0;
							y <= '0';
						else
							nstate <= s2;
							y <= '0';
						end if;
			when s2 => qout <= "10";
			
							if(x = '0') then
							nstate <= s0;
							y <= '0';
						else
							nstate <= s3;
							y <= '0';
						end if;
			when s3 => qout <= "11";
							if(x = '0') then
							nstate <= s0;
							y <= '1';
						else
							nstate <= s3;
							y <= '0';
						end if;
		end case;
	end process;
end behave;