library ieee;
use ieee.std_logic_1164.all;

entity dec38_e is
	port(
		a: in std_logic_vector(2 downto 0);
		g1,g2a,g2b: in std_logic;
		y: out std_logic_vector(7 downto 0)
		);
end entity;

architecture behave of dec38_e is
begin
	process(g1,g2a,g2b,a)
		variable g: std_logic;
	begin
		g := g1 and (not g2a) and (not g2b);
		if(g='0') then
			y <= "11111111";
		else
			case a is
				when "000" => y <= "11111110";
				when "001" => y <= "11111101";
				when "010" => y <= "11111011";
				when "011" => y <= "11110111";
				when "100" => y <= "11101111";
				when "101" => y <= "11011111";
				when "110" => y <= "10111111";
				when "111" => y <= "01111111";
				when others => y <= "11111111";
			end case;
		end if;
	end process;
end behave;