library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity counter10 is
	port(
		clk, reset, load: in std_logic;
		din: in std_logic_vector(3 downto 0);
		qout: out std_logic_vector(3 downto 0);
		c: out std_logic
		);
end counter10;

architecture art of counter10 is
	signal tmp: std_logic_vector(3 downto 0);
begin
	process(clk, reset)
	begin
		if(reset='0') then
			tmp <= "0000";
		elsif(clk'event and clk = '1') then
			if(load = '0') then
				tmp <= din;
			else
				if(tmp = "1001") then
					tmp <= "0000";
				else
					tmp <= tmp+1;
				end if;
			end if;
		end if;
	end process;
	qout <= tmp;
	c <= '1' when tmp = "1001" else
		 '0';
end art;