library ieee;
use ieee.std_logic_1164.all;

entity count8 is
	port(
		clk,y: in std_logic;
		qout: out std_logic_vector(2 downto 0)
		);
end count8;

architecture behave of count8 is
	type state is(s0,s1,s2,s3,s4,s5,s6,s7);
	signal cstate,nstate: state;
begin
	process(clk)
	begin
		if(clk'event and clk='1') then
			cstate <= nstate;
		end if;
	end process;
	process(cstate,y)
	begin
		case cstate is
			when s0 => qout <= "000";
					if(y = '1') then
						nstate <= s1;
					else
						nstate <= s7;
					end if;
			when s1 => qout <= "001";
					if(y = '1') then
						nstate <= s2;
					else
						nstate <= s0;
					end if;
			when s2 => qout <= "011";
					if(y = '1') then
						nstate <= s3;
					else
						nstate <= s1;
					end if;
			when s3 => qout <= "010";
					if(y = '1') then
						nstate <= s4;
					else
						nstate <= s2;
					end if;
			when s4 => qout <= "110";
					if(y = '1') then
						nstate <= s5;
					else
						nstate <= s3;
					end if;
			when s5 => qout <= "111";
					if(y = '1') then
						nstate <= s6;
					else
						nstate <= s4;
					end if;
			when s6 => qout <= "101";
					if(y = '1') then
						nstate <= s7;
					else
						nstate <= s5;
					end if;
			when s7 => qout <= "100";
					if(y = '1') then
						nstate <= s0;
					else
						nstate <= s6;
					end if;
		end case;
	end process;
end behave;