library ieee;
use ieee.std_logic_1164.all;

entity out4 is
	port(
		din: in std_logic_vector(7 downto 1);
		dout: out std_logic
		);
end out4;

architecture art3 of out4 is
	component nand3a
		port(
			a,b,c: in std_logic;
			d: out std_logic
			);
	end component;
	component nand2a
		port(
			a,b: in std_logic;
			c: out std_logic
			);
	end component;	
	signal dout1,dout2,dout3: std_logic;
begin
	u1: nand3a port map(din(1),din(2),din(3),dout1);
	u2: nand2a port map(din(4),din(5),dout2);
	u3: nand2a port map(din(6),din(7),dout3);
	dout <= (not dout1) or (not dout2) or (not dout3);
end art3;