library ieee;
use ieee.std_logic_1164.all;

entity check101 is
	port(
		clk,x: in std_logic;
		y: out std_logic
		);
end check101;

architecture art of check101 is
	type state is(s0,s1,s2);
	signal cstate,nstate: state;
begin
	process(clk)
	begin
		if(clk'event and clk = '1') then
			cstate <= nstate;
		end if;
	end process;
	process(cstate,x)
	begin
		case cstate is
			when s0 => if(x = '0') then
							y <= '0';
							nstate <= s0;
						else
							y <= '0';
							nstate <= s1;
						end if;
			when s1 => if(x = '0') then
							y <= '0';
							nstate <= s2;
						else
							y <= '0';
							nstate <= s1;
						end if;
			when s2 => if(x = '0') then
							y <= '0';
							nstate <= s0;
						else
							y <= '1';
							nstate <= s1;
						end if;
		end case;
	end process;
end art;