library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity counter10_ppt is
	port(
		clk,load: in std_logic;
		din: in std_logic_vector(3 downto 0);
		qout: out std_logic_vector(3 downto 0);
		c: out std_logic
		);
end counter10_ppt;

architecture art of counter10_ppt is
	signal temp: std_logic_vector(3 downto 0);
begin
	process(clk,load,din)
	begin
		if(load='0') then
			temp <= din;
		elsif(clk'event and clk='1') then
			if(temp = "1001") then
				temp <= "0000";
			else
				temp <= temp+1;
			end if;
		end if;
end process;
	qout <= temp;
	c <= '1' when temp = "1001" else
		 '0';
end art;